package cn.gov.customs.data.config;

import cn.gov.customs.data.repository.h2018.H2018Repository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.orm.jpa.JpaTransactionManager;
import org.springframework.orm.jpa.LocalContainerEntityManagerFactoryBean;
import org.springframework.orm.jpa.vendor.Database;
import org.springframework.orm.jpa.vendor.HibernateJpaVendorAdapter;
import org.springframework.transaction.PlatformTransactionManager;
import org.springframework.transaction.annotation.EnableTransactionManagement;

import javax.sql.DataSource;

/*
 * @Description:
 * @Author: wq
 * @Date: 2025/11/3.
 */

@Configuration
@EnableTransactionManagement
@EnableJpaRepositories(
        entityManagerFactoryRef="entityManagerH2018",
        transactionManagerRef="transactionManagerH2018",
        basePackages= {"cn.gov.customs.data.repository.h2018"},
        basePackageClasses = {H2018Repository.class}) //设置Repository所在位置  dao 文件的路径
public class H2018Config {

    @Autowired
    @Qualifier("h2018DataSource")
    private DataSource h2018DataSource;


    @Bean
    PlatformTransactionManager transactionManagerH2018() {
        return new JpaTransactionManager(entityManagerH2018().getObject());
    }

    @Bean
    public LocalContainerEntityManagerFactoryBean entityManagerH2018() {
        HibernateJpaVendorAdapter vendorAdapter = new HibernateJpaVendorAdapter();
        vendorAdapter.setDatabase(Database.MYSQL);
        vendorAdapter.setShowSql(true);

        LocalContainerEntityManagerFactoryBean factoryBean = new LocalContainerEntityManagerFactoryBean();
        factoryBean.setDataSource(h2018DataSource);
        factoryBean.setJpaVendorAdapter(vendorAdapter);
        factoryBean.setPackagesToScan("cn.gov.customs.data.entity.h2018*");//jpa对应的实体的位置
        return factoryBean;
    }
}
